题目描述
给你一个下标从 0 开始的整数数组 costs
,其中 costs[i]
是雇佣第 i
位工人的代价。
同时给你两个整数 k
和 candidates
。我们想根据以下规则恰好雇佣 k
位工人:
- 总共进行
k
轮雇佣,且每一轮恰好雇佣一位工人。
- 在每一轮雇佣中,从最前面
candidates
和最后面 candidates
人中选出代价最小的一位工人,如果有多位代价相同且最小的工人,选择下标更小的一位工人。
- 比方说,
costs = [3,2,7,7,1,2]
且 candidates = 2
,第一轮雇佣中,我们选择第 4
位工人,因为他的代价最小 [3,2,7,7,1,2]
。
- 第二轮雇佣,我们选择第
1
位工人,因为他们的代价与第 4
位工人一样都是最小代价,而且下标更小,[3,2,7,7,2]
。注意每一轮雇佣后,剩余工人的下标可能会发生变化。
- 如果剩余员工数目不足
candidates
人,那么下一轮雇佣他们中代价最小的一人,如果有多位代价相同且最小的工人,选择下标更小的一位工人。
- 一位工人只能被选择一次。
返回雇佣恰好 k
位工人的总代价。
示例 1:
输入:costs = [17,12,10,2,7,2,11,20,8], k = 3, candidates = 4
输出:11
解释:我们总共雇佣 3 位工人。总代价一开始为 0 。
- 第一轮雇佣,我们从 [17,12,10,2,7,2,11,20,8] 中选择。最小代价是 2 ,有两位工人,我们选择下标更小的一位工人,即第 3 位工人。总代价是 0 + 2 = 2 。
- 第二轮雇佣,我们从 [17,12,10,7,2,11,20,8] 中选择。最小代价是 2 ,下标为 4 ,总代价是 2 + 2 = 4 。
- 第三轮雇佣,我们从 [17,12,10,7,11,20,8] 中选择,最小代价是 7 ,下标为 3 ,总代价是 4 + 7 = 11 。注意下标为 3 的工人同时在最前面和最后面 4 位工人中。
总雇佣代价是 11 。
示例 2:
输入:costs = [1,2,4,1], k = 3, candidates = 3
输出:4
解释:我们总共雇佣 3 位工人。总代价一开始为 0 。
- 第一轮雇佣,我们从 [1,2,4,1] 中选择。最小代价为 1 ,有两位工人,我们选择下标更小的一位工人,即第 0 位工人,总代价是 0 + 1 = 1 。注意,下标为 1 和 2 的工人同时在最前面和最后面 3 位工人中。
- 第二轮雇佣,我们从 [2,4,1] 中选择。最小代价为 1 ,下标为 2 ,总代价是 1 + 1 = 2 。
- 第三轮雇佣,少于 3 位工人,我们从剩余工人 [2,4] 中选择。最小代价是 2 ,下标为 0 。总代价为 2 + 2 = 4 。
总雇佣代价是 4 。
提示:
1 <= costs.length <= 105
1 <= costs[i] <= 105
1 <= k, candidates <= costs.length
解法
方法一:优先队列(小根堆)
我们首先判断 $candidates \times 2$ 是否大于等于 $n$,如果是,我们直接返回前 $k$ 个最小的工人的代价之和。
否则,我们使用一个小根堆 $pq$ 来维护前 $candidates$ 个工人和后 $candidates$ 个工人的代价。
我们首先将前 $candidates$ 个工人的代价以及对应的下标加入小根堆 $pq$ 中,然后将后 $candidates$ 个工人的代价以及对应的下标加入小根堆 $pq$ 中。用两个指针 $l$ 和 $r$ 分别指向前后待选工人的下标,初始时 $l = candidates$, $r = n - candidates - 1$。
然后我们进行 $k$ 次循环,每次从小根堆 $pq$ 中取出代价最小的工人,将其代价加入答案,如果 $l > r$,说明前后待选工人已经全部被选完,直接跳过。否则,如果当前工人的下标小于 $l$,说明是前面的工人,我们将第 $l$ 个工人的代价以及下标加入小根堆 $pq$ 中,然后 $l$ 加一;否则,我们将第 $r$ 个工人的代价以及下标加入小根堆 $pq$ 中,然后 $r$ 减一。
循环结束后,返回答案即可。
时间复杂度 $O(n \times \log n)$,空间复杂度 $O(n)$。其中 $n$ 是数组 $costs$ 的长度。
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25 | class Solution:
def totalCost(self, costs: List[int], k: int, candidates: int) -> int:
n = len(costs)
if candidates * 2 >= n:
return sum(sorted(costs)[:k])
pq = []
for i, c in enumerate(costs[:candidates]):
heappush(pq, (c, i))
for i in range(n - candidates, n):
heappush(pq, (costs[i], i))
heapify(pq)
l, r = candidates, n - candidates - 1
ans = 0
for _ in range(k):
c, i = heappop(pq)
ans += c
if l > r:
continue
if i < l:
heappush(pq, (costs[l], l))
l += 1
else:
heappush(pq, (costs[r], r))
r -= 1
return ans
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33 | class Solution {
public long totalCost(int[] costs, int k, int candidates) {
int n = costs.length;
long ans = 0;
if (candidates * 2 >= n) {
Arrays.sort(costs);
for (int i = 0; i < k; ++i) {
ans += costs[i];
}
return ans;
}
PriorityQueue<int[]> pq
= new PriorityQueue<>((a, b) -> a[0] == b[0] ? a[1] - b[1] : a[0] - b[0]);
for (int i = 0; i < candidates; ++i) {
pq.offer(new int[] {costs[i], i});
pq.offer(new int[] {costs[n - i - 1], n - i - 1});
}
int l = candidates, r = n - candidates - 1;
while (k-- > 0) {
var p = pq.poll();
ans += p[0];
if (l > r) {
continue;
}
if (p[1] < l) {
pq.offer(new int[] {costs[l], l++});
} else {
pq.offer(new int[] {costs[r], r--});
}
}
return ans;
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32 | class Solution {
public:
long long totalCost(vector<int>& costs, int k, int candidates) {
int n = costs.size();
if (candidates * 2 > n) {
sort(costs.begin(), costs.end());
return accumulate(costs.begin(), costs.begin() + k, 0LL);
}
using pii = pair<int, int>;
priority_queue<pii, vector<pii>, greater<pii>> pq;
for (int i = 0; i < candidates; ++i) {
pq.emplace(costs[i], i);
pq.emplace(costs[n - i - 1], n - i - 1);
}
long long ans = 0;
int l = candidates, r = n - candidates - 1;
while (k--) {
auto [cost, i] = pq.top();
pq.pop();
ans += cost;
if (l > r) {
continue;
}
if (i < l) {
pq.emplace(costs[l], l++);
} else {
pq.emplace(costs[r], r--);
}
}
return ans;
}
};
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42 | func totalCost(costs []int, k int, candidates int) (ans int64) {
n := len(costs)
if candidates*2 > n {
sort.Ints(costs)
for _, x := range costs[:k] {
ans += int64(x)
}
return
}
pq := hp{}
for i, x := range costs[:candidates] {
heap.Push(&pq, pair{x, i})
heap.Push(&pq, pair{costs[n-i-1], n - i - 1})
}
l, r := candidates, n-candidates-1
for ; k > 0; k-- {
p := heap.Pop(&pq).(pair)
ans += int64(p.cost)
if l > r {
continue
}
if p.i < l {
heap.Push(&pq, pair{costs[l], l})
l++
} else {
heap.Push(&pq, pair{costs[r], r})
r--
}
}
return
}
type pair struct{ cost, i int }
type hp []pair
func (h hp) Len() int { return len(h) }
func (h hp) Less(i, j int) bool {
return h[i].cost < h[j].cost || (h[i].cost == h[j].cost && h[i].i < h[j].i)
}
func (h hp) Swap(i, j int) { h[i], h[j] = h[j], h[i] }
func (h *hp) Push(v any) { *h = append(*h, v.(pair)) }
func (h *hp) Pop() any { a := *h; v := a[len(a)-1]; *h = a[:len(a)-1]; return v }
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29 | function totalCost(costs: number[], k: number, candidates: number): number {
const n = costs.length;
if (candidates * 2 >= n) {
costs.sort((a, b) => a - b);
return costs.slice(0, k).reduce((acc, x) => acc + x, 0);
}
const pq = new PriorityQueue({
compare: (a, b) => (a[0] === b[0] ? a[1] - b[1] : a[0] - b[0]),
});
for (let i = 0; i < candidates; ++i) {
pq.enqueue([costs[i], i]);
pq.enqueue([costs[n - i - 1], n - i - 1]);
}
let [l, r] = [candidates, n - candidates - 1];
let ans = 0;
while (k--) {
const [cost, i] = pq.dequeue()!;
ans += cost;
if (l > r) {
continue;
}
if (i < l) {
pq.enqueue([costs[l], l++]);
} else {
pq.enqueue([costs[r], r--]);
}
}
return ans;
}
|